/*
 * Copyright (c) 2000 Dave Jones <dave@powertweak.com>
 *
 * Can be freely distributed and used under the terms of the GNU GPL.
 */

#include <gtk/gtk.h>
#include <procxml.h>
#include "tickbuttons.h"
#include "powertweak.h"


extern void modify_tweak_info (GtkWidget *, const char *);

static void toggle_tick (GtkWidget __unused *widget, char *value)
{
	if (*value)
		*value=0;
	else
		*value=1;
}


static GtkWidget *CreateTick(const char *label, char __unused *description, GtkWidget *table, int column, char defaultvalue,
					char *currentstateptr)
{
	GtkWidget *tickbutton;

	tickbutton = gtk_check_button_new_with_label (label);

	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(tickbutton), defaultvalue); 

	gtk_table_attach(GTK_TABLE(table), tickbutton, 0, 1, column, column+1,
					GTK_FILL|GTK_EXPAND, 0, 5, 5);

	gtk_signal_connect (GTK_OBJECT (tickbutton), "clicked", GTK_SIGNAL_FUNC (toggle_tick), currentstateptr);
/*	gtk_signal_connect (GTK_OBJECT (tickbutton), "enter", GTK_SIGNAL_FUNC (modify_tweak_info), description);*/
	gtk_widget_show(tickbutton);

	return (tickbutton);
}


void Create_XML_TickButton(struct xml_item *xml_item, GtkWidget *table, int column)
{
	xml_item->widget = CreateTick (xml_item->Name,
									xml_item->Description,
									table, column,
									xml_item->BoolValue,
									&xml_item->BoolValue );
}
