/*
 * Copyright (c) 2000 Dave Jones <dave@powertweak.com>
 * Heavy modifications by Arjan van de Ven <arjan@fenrus.demon.nl>
 *
 * Can be freely distributed and used under the terms of the GNU GPL.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "gadgets/spinbuttons.h"
#include "gadgets/tickbuttons.h"
#include "../notebook.h"
#include "../create-GUI.h"

#include <procxml.h>

extern char fileexists(const char *filename);
void Change_XMLSpinButton(GtkWidget *widget, struct xml_item *xml_item);
void CreateXMLSpinButton(struct xml_item *xml_item, GtkWidget *table, int column);
void Create_XML_TickButton(struct xml_item *xml_item, GtkWidget *table, int column);



extern GtkText *TweakInfoTextPtr;

char *strdupcat(char *S1, char *S2)
{
	if (S2 == NULL)
		return S1;

	if (S1 == NULL)
		return strdup(S2);

	S1 = realloc(S1, strlen(S1) + strlen(S2) + 4);
	if (S1 == NULL)
		return NULL;

	strncat(S1, S2,strlen(S1)+strlen(S2)+2);
	return S1;
}

void show_XML_tabs(struct menuitem *menuitem)
{

	struct menuitem *iterator;

	GtkWidget *scrolled_win_top;
	GtkWidget *scrolled_win_bottom=NULL;
	GtkWidget *table;
	GtkWidget *vbox;

	int column = 0;
	char *descriptions = NULL;



	while (menuitem != NULL) {
		/* See if there is anything to show */
		if (menuitem->ActiveCount==0) {
			menuitem=menuitem->Next;
			continue;
		}
		column = 0;

		/* PAGE ONE (Spinbuttons) */
		AddPage(GTK_NOTEBOOK(notebook), menuitem->Name);

		/* Top half */
		scrolled_win_top = gtk_scrolled_window_new(NULL, NULL);
		gtk_widget_set_usize(scrolled_win_top, (WindowWidth / 3) * 2, 150);
		gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_win_top),
					       GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

		table = gtk_table_new(menuitem->ActiveCount, 1, TRUE);


		iterator = menuitem->Submenus;
		while (iterator != NULL) {
			if ((iterator->xml_item != NULL)&&(iterator->xml_item->Type!=NULL))
				if (fileexists(iterator->xml_item->File) == TRUE) {
					if (strcmp(iterator->xml_item->Type, "Spinbutton") == 0) {
						CreateXMLSpinButton(iterator->xml_item, table, column);
						descriptions = strdupcat(descriptions, iterator->xml_item->Description);
						column++;
					}
					if (strcmp(iterator->xml_item->Type, "Checkbox") == 0) {
						Create_XML_TickButton(iterator->xml_item, table, column);
						descriptions = strdupcat(descriptions, iterator->xml_item->Description);
						column++;
					}

				}
			iterator = iterator->Next;
		}

		gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrolled_win_top), table);

		gtk_widget_show(table);
		gtk_widget_show(scrolled_win_top);

		/* Bottom half */
		if (descriptions != NULL) {
			scrolled_win_bottom = gtk_scrolled_window_new(NULL, NULL);
			gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_win_bottom),
					       GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
			TweakInfoTextPtr = (GTK_TEXT(CreateText(descriptions)));
			gtk_container_add(GTK_CONTAINER(scrolled_win_bottom), (GTK_WIDGET(TweakInfoTextPtr)));
		
		gtk_widget_show(scrolled_win_bottom);
		}
		/* Create both halves. */
		vbox = gtk_vbox_new(FALSE, 0);
		gtk_box_pack_start(GTK_BOX(vbox), scrolled_win_top, TRUE, TRUE, 0);
		if (descriptions != NULL)
			gtk_box_pack_start(GTK_BOX(vbox), scrolled_win_bottom, TRUE, TRUE, 0);
		gtk_widget_show(vbox);
		gtk_container_add(GTK_CONTAINER(current_pages[current_max_page - 1]), vbox);

		menuitem = menuitem->Next;
		free(descriptions);
		descriptions = NULL;
	}

}

