/* Copyright 2000 Red Hat, Inc.
 *
 * Bernhard Rosenkrnzer <bero@redhat.com>
 *
 * This software may be freely redistributed under the terms of the GNU
 * public license.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtk/gtk.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define RHC_INTERNAL
#include "rhutil.h"
#include <errno.h>

void
vError (const char *fmt, va_list ap)
{
	GtkWidget *window, *vbox, *button, *label;
	char buf[2048];

	(void) vsnprintf (buf, sizeof buf, fmt, ap);

	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_widget_set_usize (GTK_WIDGET (window), 200, 100);
	gtk_window_set_title (GTK_WINDOW (window), rhcl_title ());
	gtk_container_set_border_width (GTK_CONTAINER (window), 5);
	gtk_signal_connect (GTK_OBJECT (window), "destroy",
		GTK_SIGNAL_FUNC (CloseDisplay), NULL);

	vbox = gtk_vbox_new (FALSE, 0);
	gtk_container_add (GTK_CONTAINER (window), vbox);
	gtk_widget_show (vbox);

	label = gtk_label_new (buf);
	gtk_box_pack_start (GTK_BOX (vbox), label, TRUE, TRUE, 0);
	gtk_widget_show (label);

	button = gtk_button_new_with_label (_("Ok"));
	gtk_box_pack_start (GTK_BOX (vbox), button, FALSE, FALSE, 0);
	GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
	gtk_widget_grab_default (button);
	gtk_widget_show (button);

	gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
		GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (window));

	gtk_widget_show (window);
	gtk_main ();
}
