/* Copyright 2000 Red Hat, Inc.
 *
 * Florian La Roche <Florian.LaRoche@redhat.de>
 *
 * This software may be freely redistributed under the terms of the GNU
 * public license.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "rhutil.h"
#include <ctype.h>

char *
string_trim (const char *s, size_t n, size_t *out_size)
{
	/* skip whitespace at the beginning of data */
	for (; n && isspace ((unsigned char)*s); s++, n--)
		;
	/* trim whitespace at the end */
	for (; n && isspace ((unsigned char)(s[n - 1])); n--)
		;
	/* copy into newly malloced buffer */
	if (out_size)
		*out_size = n;
	return rh_xstrndup (s, n);
}
